/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.133
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.76 2010/07/03 15:49:39 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.133 2012/06/18 21:33:50 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21else 49if version_is_at_least 4.8; then
22 MY_P=qt-x11-opensource-src-${MY_PV} 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
51 version_is_at_least 4.8.3 || IUSE+=" qpa"
23fi 52fi
24 53
25HOMEPAGE="http://qt.nokia.com/" 54DEPEND="virtual/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
27 56 DEPEND+=" dev-lang/perl"
28LICENSE="|| ( LGPL-2.1 GPL-3 )" 57fi
29IUSE+=" debug pch aqua"
30 58
31RDEPEND=" 59RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
33 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
34 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
35 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
36 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
37 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
38 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
39 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
40 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
41 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
42 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
43 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
44 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
45 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
46 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
47 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
48 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
49 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
50 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
51 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
52 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
53 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
54 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
55 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
56 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
57 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
58 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
59 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
60 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
62" 96"
63 97
64S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
65 99
66# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 101# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 105
72 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
73 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 112 die "aborting to save your system"
79 else 113 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 115 fi
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 116 fi
96 117
97 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 125 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 129 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
122 137
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
124# @DESCRIPTION: 140# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 143
133# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 145# @DESCRIPTION:
135# Unpacks the sources 146# Unpacks the sources.
136qt4-build_src_unpack() { 147qt4-build_src_unpack() {
137 setqtenv 148 setqtenv
138 local target targets= 149
150 if ! version_is_at_least 4.1 $(gcc-version); then
151 ewarn "Using a GCC version lower than 4.1 is not supported."
152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
142 targets+=" ${MY_P}/${target}" 177 targets+="${MY_P}/${target} "
143 done 178 done
144 179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 182 eend $? || die "failed to unpack"
183 ;;
184 esac
147} 185}
148 186
149# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
150# @DESCRIPTION: 189# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
153# example: 192# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
155# ${FILESDIR}"/mypatch2.patch"
156# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
157 199
158# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 201# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
162qt4-build_src_prepare() { 204qt4-build_src_prepare() {
163 setqtenv 205 setqtenv
164 cd "${S}"
165 206
166 # fix qt 4.7 regression that skips -fvisibility=hidden 207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
167 if version_is_at_least "4.7.0_beta1"; then 211 if version_is_at_least 4.7; then
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 212 # avoid X11 dependency in non-gui packages
169 -i config.tests/unix/fvisibility.test || 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
170 die "visibility fixing sed failed" 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
171 fi 215 fi
172 216
173 if use aqua; then 217 if use aqua; then
174 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 220
177 sed -e '/^CONFIG/s:app_bundle::' \ 221 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 224 fi
181 225
182 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
183 skip_qmake_build_patch 227 skip_qmake_build
184 skip_project_generation_patch 228 skip_project_generation
185 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
186 fi 230 fi
187 231
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
190 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
191 fi 236 fi
192 237
193 # Bug 178652 238 # Bug 178652
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse 241 append-flags -fno-gcse
197 fi 242 fi
198 243
244 if use_if_iuse c++0x; then
245 append-cxxflags -std=c++0x
246 fi
247
199 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
203 # Bug 253127 252 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
206 fi 255 fi
207 256
208 # Bug 261632 257 # Bug 261632
209 if use ppc64; then 258 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 260 append-flags -mminimal-toc
212 fi 261 fi
213 262
214 # Bug 282984 && Bug 295530 263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 264 sed -e "/^SYSTEM_VARIABLES=/i \
216 -i configure || die "sed qmake compilers failed" 265 CC='$(tc-getCC)'\n\
217 # bug 321335 266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n" \
270 -i configure \
271 || die "sed SYSTEM_VARIABLES failed"
272
273 # Respect CC, CXX, LINK and *FLAGS in config.tests
274 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
275 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
276 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
277 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
278 || die "sed config.tests failed"
279
218 if version_is_at_least 4.6; then 280 if ! version_is_at_least 4.8; then
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 281 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
220 xargs -0 \ 282 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \
222 -i || die "sed test compilers failed"
223 fi 283 fi
224 284
225 # Bug 172219 285 # Bug 172219
226 sed -e "s:X11R6/::" \ 286 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 287
229 if [[ ${CHOST} == *-darwin* ]]; then 288 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 289 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 290 # crippled (by design) :/
291 local mac_gpp_conf=
292 if [[ -f mkspecs/common/mac-g++.conf ]]; then
293 # qt < 4.8 has mac-g++.conf
294 mac_gpp_conf="mkspecs/common/mac-g++.conf"
295 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
296 # qt >= 4.8 has g++-macx.conf
297 mac_gpp_conf="mkspecs/common/g++-macx.conf"
298 else
299 die "no known conf file for mac found"
300 fi
301 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 302 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 303 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 304 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 305 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 306 -i ${mac_gpp_conf} \
307 || die "sed ${mac_gpp_conf} failed"
237 308
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 309 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 310 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 311 # pch). Additionally disable Xarch support.
312 local mac_gcc_confs="${mac_gpp_conf}"
313 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
314 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
315 fi
241 sed \ 316 sed \
242 -e "s:-arch i386::" \ 317 -e "s:-arch i386::" \
243 -e "s:-arch ppc::" \ 318 -e "s:-arch ppc::" \
244 -e "s:-arch x86_64::" \ 319 -e "s:-arch x86_64::" \
245 -e "s:-arch ppc64::" \ 320 -e "s:-arch ppc64::" \
246 -e "s:-arch \$i::" \ 321 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 322 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 323 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 324 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 325 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 326 -i configure ${mac_gcc_confs} \
327 || die "sed -arch/-Xarch failed"
252 328
253 # On Snow Leopard don't fall back to 10.5 deployment target. 329 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 330 if [[ ${CHOST} == *-apple-darwin10 ]]; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 331 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 332 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 333 -i configure ${mac_gpp_conf} \
334 || die "sed deployment target failed"
258 fi 335 fi
259 fi 336 fi
260 337
261 # this one is needed for all systems with a separate -liconv, apart from 338 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 339 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 340 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
264 sed \ 341 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 342 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 343 || die "sed iconv.pro failed"
268 fi 344 fi
269 345
270 # we need some patches for Solaris 346 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 347 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 348 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 349 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 350 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 351 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 352 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 353 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 # strip predefined CFLAGS from qmake ( bug #312689 )
280 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
281 354
282 base_src_prepare 355 base_src_prepare
283} 356}
284 357
285# @FUNCTION: qt4-build_src_configure 358# @FUNCTION: qt4-build_src_configure
286# @DESCRIPTION: 359# @DESCRIPTION:
287# Default configure phase 360# Default configure phase
288qt4-build_src_configure() { 361qt4-build_src_configure() {
289 setqtenv 362 setqtenv
290 myconf="$(standard_configure_options) ${myconf}" 363
364 local conf="
365 -prefix ${QTPREFIXDIR}
366 -bindir ${QTBINDIR}
367 -libdir ${QTLIBDIR}
368 -docdir ${QTDOCDIR}
369 -headerdir ${QTHEADERDIR}
370 -plugindir ${QTPLUGINDIR}
371 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
372 -datadir ${QTDATADIR}
373 -translationdir ${QTTRANSDIR}
374 -sysconfdir ${QTSYSCONFDIR}
375 -examplesdir ${QTEXAMPLESDIR}
376 -demosdir ${QTDEMOSDIR}
377 -opensource -confirm-license
378 -shared -fast -largefile -stl -verbose
379 -nomake examples -nomake demos"
380
381 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
382 # $(tc-arch). Therefore we convert it to supported values.
383 case "$(tc-arch)" in
384 amd64|x64-*) conf+=" -arch x86_64" ;;
385 ppc-macos) conf+=" -arch ppc" ;;
386 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
387 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
388 x86-macos) conf+=" -arch x86" ;;
389 x86|x86-*) conf+=" -arch i386" ;;
390 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
391 hppa|sh) conf+=" -arch generic" ;;
392 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
393 esac
394
395 conf+=" -platform $(qt_mkspecs_dir)"
396
397 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
398
399 # debug/release
400 if use debug; then
401 conf+=" -debug"
402 else
403 conf+=" -release"
404 fi
405 conf+=" -no-separate-debug-info"
406
407 # exceptions USE flag
408 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
409
410 # disable rpath on Qt >= 4.8 (bug 380415)
411 # but leave it enabled on prefix (bug 417169)
412 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
413
414 # precompiled headers don't work on hardened, where the flag is masked
415 conf+=" $(qt_use pch)"
416
417 # -reduce-relocations
418 # This flag seems to introduce major breakage to applications,
419 # mostly to be seen as a core dump with the message "QPixmap: Must
420 # construct a QApplication before a QPaintDevice" on Solaris.
421 # -- Daniel Vergien
422 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
291 423
292 # this one is needed for all systems with a separate -liconv, apart from 424 # this one is needed for all systems with a separate -liconv, apart from
293 # Darwin, for which the sources already cater for -liconv 425 # Darwin, for which the sources already cater for -liconv
294 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 426 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
295 myconf+=" -liconv" 427 conf+=" -liconv"
428 fi
296 429
297 if has glib ${IUSE//+} && use glib; then 430 if use_if_iuse glib; then
298 # use -I, -L and -l from configure
299 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 431 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
300 # avoid the -pthread argument 432 # avoid the -pthread argument
301 myconf+=" ${glibflags//-pthread}" 433 conf+=" ${glibflags//-pthread}"
302 unset glibflags 434 unset glibflags
303 fi 435 fi
304 436
437 if use_if_iuse qpa; then
438 echo
439 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
440 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
441 ewarn "disable it before reporting any bugs related to this useflag."
442 echo
443 conf+=" -qpa"
444 fi
445
305 if use aqua ; then 446 if use aqua; then
306 # On (snow) leopard use the new (frameworked) cocoa code. 447 # On (snow) leopard use the new (frameworked) cocoa code.
307 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 448 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
308 myconf+=" -cocoa -framework" 449 conf+=" -cocoa -framework"
450 # We need the source's headers, not the installed ones.
451 conf+=" -I${S}/include"
452 # Add hint for the framework location.
453 conf+=" -F${QTLIBDIR}"
309 454
310 # We are crazy and build cocoa + qt3support :-) 455 # We are crazy and build cocoa + qt3support :-)
311 if use qt3support; then 456 if use qt3support; then
312 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 457 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
313 -i configure 458 -i configure || die
314 fi 459 fi
315 460 else
316 # We need the source's headers, not the installed ones. 461 conf+=" -no-framework"
317 myconf+=" -I${S}/include"
318
319 # Add hint for the framework location.
320 myconf+=" -F${QTLIBDIR}"
321 fi 462 fi
322 else 463 else
323 # freetype2 include dir is non-standard, thus include it on configure 464 # freetype2 include dir is non-standard, thus pass it to configure
324 # use -I from configure
325 myconf+=" $(pkg-config --cflags freetype2)" 465 conf+=" $(pkg-config --cflags-only-I freetype2)"
326 fi 466 fi
327 467
468 conf+=" ${myconf}"
469 myconf=
470
328 echo ./configure ${myconf} 471 echo ./configure ${conf}
329 ./configure ${myconf} || die "./configure failed" 472 ./configure ${conf} || die "./configure failed"
330 myconf="" 473
474 prepare_directories ${QT4_TARGET_DIRECTORIES}
331} 475}
332 476
333# @FUNCTION: qt4-build_src_compile 477# @FUNCTION: qt4-build_src_compile
478# @DESCRIPTION:
334# @DESCRIPTION: Actual compile phase 479# Actual compile phase
335qt4-build_src_compile() { 480qt4-build_src_compile() {
336 setqtenv 481 setqtenv
337 482
338 build_directories ${QT4_TARGET_DIRECTORIES} 483 build_directories ${QT4_TARGET_DIRECTORIES}
339} 484}
340 485
341# @FUNCTION: qt4-build_src_test 486# @FUNCTION: qt4-build_src_test
342# @DESCRIPTION: 487# @DESCRIPTION:
343# Runs tests only in target directories. 488# Runs tests only in target directories.
344qt4-build_src_test() { 489qt4-build_src_test() {
490 # QtMultimedia does not have any test suite (bug #332299)
491 [[ ${PN} == qt-multimedia ]] && return
492
345 for dir in ${QT4_TARGET_DIRECTORIES}; do 493 for dir in ${QT4_TARGET_DIRECTORIES}; do
346 emake -j1 check -C ${dir} 494 emake -j1 check -C ${dir}
347 done 495 done
348} 496}
349 497
350# @FUNCTION: fix_includes 498# @FUNCTION: fix_includes
351# @DESCRIPTION: 499# @DESCRIPTION:
352# For MacOSX we need to add some symlinks when frameworks are 500# For MacOS X we need to add some symlinks when frameworks are
353# being used, to avoid complications with some more or less stupid packages. 501# being used, to avoid complications with some more or less stupid packages.
354fix_includes() { 502fix_includes() {
355 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 503 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
504 local frw dest f h rdir
356 # Some packages tend to include <Qt/...> 505 # Some packages tend to include <Qt/...>
357 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 506 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
358 507
359 # Fake normal headers when frameworks are installed... eases life later on 508 # Fake normal headers when frameworks are installed... eases life later
360 local dest f 509 # on, make sure we use relative links though, as some ebuilds assume
510 # these dirs exist in src_install to add additional files
511 f=${QTHEADERDIR}
512 h=${QTLIBDIR}
513 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
514 f=${f#*/}
515 h=${h#*/}
516 done
517 rdir=${h}
518 f="../"
519 while [[ ${h} == */* ]] ; do
520 f="${f}../"
521 h=${h#*/}
522 done
523 rdir="${f}${rdir}"
524
361 for frw in "${D}${QTLIBDIR}"/*.framework; do 525 for frw in "${D}${QTLIBDIR}"/*.framework; do
362 [[ -e "${frw}"/Headers ]] || continue 526 [[ -e "${frw}"/Headers ]] || continue
363 f=$(basename ${frw}) 527 f=$(basename ${frw})
364 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 528 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
365 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 529 dosym "${rdir}"/${f}/Headers "${dest}"
366 530
367 # Link normal headers as well. 531 # Link normal headers as well.
368 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 532 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
369 h=$(basename ${hdr}) 533 h=$(basename ${hdr})
370 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 534 dosym "../${rdir}"/${f}/Headers/${h} \
535 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
371 done 536 done
372 done 537 done
373 fi 538 fi
374} 539}
375 540
377# @DESCRIPTION: 542# @DESCRIPTION:
378# Perform the actual installation including some library fixes. 543# Perform the actual installation including some library fixes.
379qt4-build_src_install() { 544qt4-build_src_install() {
380 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 545 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
381 setqtenv 546 setqtenv
547
382 install_directories ${QT4_TARGET_DIRECTORIES} 548 install_directories ${QT4_TARGET_DIRECTORIES}
383 install_qconfigs 549 install_qconfigs
384 fix_library_files 550 fix_library_files
385 fix_includes 551 fix_includes
552
553 # remove .la files since we are building only shared Qt libraries
554 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
386} 555}
387 556
388# @FUNCTION: setqtenv 557# @FUNCTION: setqtenv
558# @INTERNAL
389setqtenv() { 559setqtenv() {
390 # Set up installation directories 560 # Set up installation directories
391 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
392 QTPREFIXDIR=${EPREFIX}/usr 561 QTPREFIXDIR=${EPREFIX}/usr
393 QTBINDIR=${EPREFIX}/usr/bin 562 QTBINDIR=${EPREFIX}/usr/bin
394 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 563 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
395 QMAKE_LIBDIR_QT=${QTLIBDIR}
396 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 564 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
397 QTDATADIR=${EPREFIX}/usr/share/qt4
398 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 565 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
399 QTHEADERDIR=${EPREFIX}/usr/include/qt4 566 QTHEADERDIR=${EPREFIX}/usr/include/qt4
400 QTPLUGINDIR=${QTLIBDIR}/plugins 567 QTPLUGINDIR=${QTLIBDIR}/plugins
568 QTIMPORTDIR=${QTLIBDIR}/imports
569 QTDATADIR=${EPREFIX}/usr/share/qt4
570 QTTRANSDIR=${QTDATADIR}/translations
401 QTSYSCONFDIR=${EPREFIX}/etc/qt4 571 QTSYSCONFDIR=${EPREFIX}/etc/qt4
402 QTTRANSDIR=${QTDATADIR}/translations
403 QTEXAMPLESDIR=${QTDATADIR}/examples 572 QTEXAMPLESDIR=${QTDATADIR}/examples
404 QTDEMOSDIR=${QTDATADIR}/demos 573 QTDEMOSDIR=${QTDATADIR}/demos
574 QMAKE_LIBDIR_QT=${QTLIBDIR}
405 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 575 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
576
406 PLATFORM=$(qt_mkspecs_dir) 577 PLATFORM=$(qt_mkspecs_dir)
407
408 unset QMAKESPEC 578 unset QMAKESPEC
409}
410 579
411# @FUNCTION: standard_configure_options 580 export XDG_CONFIG_HOME="${T}"
412# @DESCRIPTION:
413# Sets up some standard configure options, like libdir (if necessary), whether
414# debug info is wanted or not.
415standard_configure_options() {
416 local myconf=
417
418 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
419
420 # Disable visibility explicitly if gcc version isn't 4
421 if [[ $(gcc-major-version) -lt 4 ]]; then
422 myconf+=" -no-reduce-exports"
423 fi
424
425 # precompiled headers doesn't work on hardened, where the flag is masked.
426 myconf+=" $(qt_use pch)"
427
428 if use debug; then
429 myconf+=" -debug"
430 else
431 myconf+=" -release"
432 fi
433 myconf+=" -no-separate-debug-info"
434
435 use aqua && myconf+=" -no-framework"
436
437 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
438 # $(tc-arch). Therefore we convert it to supported values.
439 case "$(tc-arch)" in
440 amd64|x64-*) myconf+=" -arch x86_64" ;;
441 ppc-macos) myconf+=" -arch ppc" ;;
442 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
443 sparc|sparc-*) myconf+=" -arch sparc" ;;
444 x86-macos) myconf+=" -arch x86" ;;
445 x86|x86-*) myconf+=" -arch i386" ;;
446 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
447 hppa|sh) myconf+=" -arch generic" ;;
448 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
449 esac
450
451 # 4.5: build everything but qt-xmlpatterns w/o exceptions
452 # 4.6: exceptions USE flag
453 local exceptions="-exceptions"
454 case "${PV}" in
455 4.5.*)
456 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
457 ;;
458 *)
459 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
460 ;;
461 esac
462
463 # note about -reduce-relocations:
464 # That flag seems to introduce major breakage to applications,
465 # mostly to be seen as a core dump with the message "QPixmap: Must
466 # construct a QApplication before a QPaintDevice" on Solaris
467 # -- Daniel Vergien
468 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
469
470 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
471 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
472 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
473 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
474 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
475 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
476 ${exceptions}
477 -nomake examples -nomake demos"
478
479 echo "${myconf}"
480} 581}
481 582
482# @FUNCTION: build_directories 583# @FUNCTION: prepare_directories
483# @USAGE: < directories > 584# @USAGE: < directories >
585# @INTERNAL
484# @DESCRIPTION: 586# @DESCRIPTION:
485# Compiles the code in $QT4_TARGET_DIRECTORIES 587# Generates Makefiles for the given list of directories.
486build_directories() { 588prepare_directories() {
487 for x in "$@"; do 589 for x in "$@"; do
488 pushd "${S}"/${x} >/dev/null 590 pushd "${S}"/${x} >/dev/null || die
591 einfo "Running qmake in: ${x}"
489 # avoid running over the maximum argument number, bug #299810 592 # avoid running over the maximum argument number, bug #299810
490 { 593 {
491 echo "${S}"/mkspecs/common/*.conf 594 echo "${S}"/mkspecs/common/*.conf
492 find "${S}" -name '*.pr[io]' 595 find "${S}" -name '*.pr[io]'
493 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 596 } | xargs sed -i \
597 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
598 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
599 || die
494 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 600 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
601 popd >/dev/null || die
602 done
603}
604
605
606# @FUNCTION: build_directories
607# @USAGE: < directories >
608# @INTERNAL
609# @DESCRIPTION:
610# Compiles the code in the given list of directories.
611build_directories() {
612 for x in "$@"; do
613 pushd "${S}"/${x} >/dev/null || die
495 emake CC="$(tc-getCC)" \ 614 emake CC="$(tc-getCC)" \
496 CXX="$(tc-getCXX)" \ 615 CXX="$(tc-getCXX)" \
497 LINK="$(tc-getCXX)" || die "emake failed" 616 LINK="$(tc-getCXX)" || die "emake failed"
498 popd >/dev/null 617 popd >/dev/null || die
499 done 618 done
500} 619}
501 620
502# @FUNCTION: install_directories 621# @FUNCTION: install_directories
503# @USAGE: < directories > 622# @USAGE: < directories >
623# @INTERNAL
504# @DESCRIPTION: 624# @DESCRIPTION:
505# run emake install in the given directories, which are separated by spaces 625# Runs emake install in the given directories, which are separated by spaces.
506install_directories() { 626install_directories() {
507 for x in "$@"; do 627 for x in "$@"; do
508 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 628 pushd "${S}"/${x} >/dev/null || die
509 emake INSTALL_ROOT="${D}" install || die "emake install failed" 629 emake INSTALL_ROOT="${D}" install || die "emake install failed"
510 popd >/dev/null || die "Can't popd from ${S}/${x}" 630 popd >/dev/null || die
511 done 631 done
512} 632}
513 633
514# @ECLASS-VARIABLE: QCONFIG_ADD 634# @ECLASS-VARIABLE: QCONFIG_ADD
515# @DESCRIPTION: 635# @DESCRIPTION:
525# @DESCRIPTION: 645# @DESCRIPTION:
526# List variables that should be defined at the top of QtCore/qconfig.h 646# List variables that should be defined at the top of QtCore/qconfig.h
527: ${QCONFIG_DEFINE:=} 647: ${QCONFIG_DEFINE:=}
528 648
529# @FUNCTION: install_qconfigs 649# @FUNCTION: install_qconfigs
650# @INTERNAL
651# @DESCRIPTION:
530# @DESCRIPTION: Install gentoo-specific mkspecs configurations 652# Install gentoo-specific mkspecs configurations.
531install_qconfigs() { 653install_qconfigs() {
532 local x 654 local x
533 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 655 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
534 for x in QCONFIG_ADD QCONFIG_REMOVE; do 656 for x in QCONFIG_ADD QCONFIG_REMOVE; do
535 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 657 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
546 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 668 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
547 fi 669 fi
548} 670}
549 671
550# @FUNCTION: generate_qconfigs 672# @FUNCTION: generate_qconfigs
551# @DESCRIPTION: Generates gentoo-specific configurations 673# @INTERNAL
674# @DESCRIPTION:
675# Generates gentoo-specific qconfig.{h,pri}.
552generate_qconfigs() { 676generate_qconfigs() {
553 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 677 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
554 local x qconfig_add qconfig_remove qconfig_new 678 local x qconfig_add qconfig_remove qconfig_new
555 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 679 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
556 [[ -f ${x} ]] || continue 680 [[ -f ${x} ]] || continue
557 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 681 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
558 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 682 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
570 694
571 # generate list of QT_CONFIG entries from the existing list 695 # generate list of QT_CONFIG entries from the existing list
572 # including qconfig_add and excluding qconfig_remove 696 # including qconfig_add and excluding qconfig_remove
573 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 697 for x in $(sed -n 's/^QT_CONFIG +=//p' \
574 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 698 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
575 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 699 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
576 done 700 done
577 701
578 # replace the existing QT_CONFIG list with qconfig_new 702 # replace the existing QT_CONFIG list with qconfig_new
579 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 703 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
580 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 704 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
604 fi 728 fi
605 fi 729 fi
606} 730}
607 731
608# @FUNCTION: qt4-build_pkg_postrm 732# @FUNCTION: qt4-build_pkg_postrm
733# @DESCRIPTION:
609# @DESCRIPTION: Generate configurations when the package is completely removed 734# Regenerate configuration when the package is completely removed.
610qt4-build_pkg_postrm() { 735qt4-build_pkg_postrm() {
611 generate_qconfigs 736 generate_qconfigs
612} 737}
613 738
614# @FUNCTION: qt4-build_pkg_postinst 739# @FUNCTION: qt4-build_pkg_postinst
740# @DESCRIPTION:
615# @DESCRIPTION: Generate configuration, plus throws a message about possible 741# Regenerate configuration, plus throw a message about possible
616# breakages and proposed solutions. 742# breakages and proposed solutions.
617qt4-build_pkg_postinst() { 743qt4-build_pkg_postinst() {
618 generate_qconfigs 744 generate_qconfigs
619} 745}
620 746
621# @FUNCTION: skip_qmake_build_patch 747# @FUNCTION: skip_qmake_build
748# @INTERNAL
622# @DESCRIPTION: 749# @DESCRIPTION:
623# Don't need to build qmake, as it's already installed from qt-core 750# Patches configure to skip qmake compilation, as it's already installed by qt-core.
624skip_qmake_build_patch() { 751skip_qmake_build() {
625 # Don't need to build qmake, as it's already installed from qt-core
626 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 752 sed -i -e "s:if true:if false:g" "${S}"/configure || die
627} 753}
628 754
629# @FUNCTION: skip_project_generation_patch 755# @FUNCTION: skip_project_generation
756# @INTERNAL
630# @DESCRIPTION: 757# @DESCRIPTION:
631# Exit the script early by throwing in an exit before all of the .pro files are scanned 758# Exit the script early by throwing in an exit before all of the .pro files are scanned.
632skip_project_generation_patch() { 759skip_project_generation() {
633 # Exit the script early by throwing in an exit before all of the .pro files are scanned
634 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 760 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
635 -i "${S}"/configure || die "Sed failed"
636} 761}
637 762
638# @FUNCTION: symlink_binaries_to_buildtree 763# @FUNCTION: symlink_binaries_to_buildtree
764# @INTERNAL
639# @DESCRIPTION: 765# @DESCRIPTION:
640# Symlink generated binaries to buildtree so they can be used during compilation 766# Symlinks generated binaries to buildtree, so they can be used during compilation time.
641# time
642symlink_binaries_to_buildtree() { 767symlink_binaries_to_buildtree() {
643 for bin in qmake moc uic rcc; do 768 for bin in qmake moc uic rcc; do
644 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 769 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
645 done 770 done
646} 771}
647 772
648# @FUNCTION: fix_library_files 773# @FUNCTION: fix_library_files
774# @INTERNAL
649# @DESCRIPTION: 775# @DESCRIPTION:
650# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 776# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
651# moves the *.pc-files into the pkgconfig directory 777# moves the *.pc files into the pkgconfig directory.
652fix_library_files() { 778fix_library_files() {
779 local libfile
653 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 780 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
654 if [[ -e ${libfile} ]]; then 781 if [[ -e ${libfile} ]]; then
655 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 782 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
656 fi 783 fi
657 done 784 done
658 785
659 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 786 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
660 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 787 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
661 if [[ -e ${libfile} ]]; then 788 if [[ -e ${libfile} ]]; then
662 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 789 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
663 790
664 # Move .pc files into the pkgconfig directory 791 # Move .pc files into the pkgconfig directory
665 dodir ${QTPCDIR#${EPREFIX}} 792 dodir ${QTPCDIR#${EPREFIX}}
666 mv ${libfile} "${D}"/${QTPCDIR}/ \ 793 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
667 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
668 fi 794 fi
669 done 795 done
670 796
671 # Don't install an empty directory 797 # Don't install an empty directory
672 rmdir "${D}"/${QTLIBDIR}/pkgconfig 798 rmdir "${D}"/${QTLIBDIR}/pkgconfig
673} 799}
674 800
675# @FUNCTION: qt_use 801# @FUNCTION: qt_use
676# @USAGE: < flag > [ feature ] [ enableval ] 802# @USAGE: < flag > [ feature ] [ enableval ]
677# @DESCRIPTION: 803# @DESCRIPTION:
678# This will echo "${enableval}-${feature}" if <flag> is enabled, or 804# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
679# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 805# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
680# will be used for that. If [enableval] is not specified, it omits the 806# will be used for that. If [enableval] is not specified, it omits the
681# assignment-part 807# "-${enableval}" part.
682qt_use() { 808qt_use() {
683 local flag=$1 809 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
684 local feature=$1
685 local enableval=
686
687 [[ -n $2 ]] && feature=$2
688 [[ -n $3 ]] && enableval=-$3
689
690 if use ${flag}; then
691 echo "${enableval}-${feature}"
692 else
693 echo "-no-${feature}"
694 fi
695} 810}
696 811
697# @FUNCTION: qt_mkspecs_dir 812# @FUNCTION: qt_mkspecs_dir
698# @RETURN: the specs-directory w/o path 813# @RETURN: the specs-directory w/o path
699# @DESCRIPTION: 814# @DESCRIPTION:
700# Allows us to define which mkspecs dir we want to use. 815# Allows us to define which mkspecs dir we want to use.
701qt_mkspecs_dir() { 816qt_mkspecs_dir() {
702 # Allows us to define which mkspecs dir we want to use.
703 local spec 817 local spec=
704 818
705 case ${CHOST} in 819 case "${CHOST}" in
706 *-freebsd*|*-dragonfly*) 820 *-freebsd*|*-dragonfly*)
707 spec=freebsd ;; 821 spec=freebsd ;;
708 *-openbsd*) 822 *-openbsd*)
709 spec=openbsd ;; 823 spec=openbsd ;;
710 *-netbsd*) 824 *-netbsd*)
721 *-solaris*) 835 *-solaris*)
722 spec=solaris ;; 836 spec=solaris ;;
723 *-linux-*|*-linux) 837 *-linux-*|*-linux)
724 spec=linux ;; 838 spec=linux ;;
725 *) 839 *)
726 die "Unknown CHOST, no platform choosen." 840 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
727 esac 841 esac
728 842
729 CXX=$(tc-getCXX) 843 case "$(tc-getCXX)" in
730 if [[ ${CXX} == *g++* ]]; then 844 *g++*)
731 spec+=-g++ 845 spec+=-g++ ;;
732 elif [[ ${CXX} == *icpc* ]]; then 846 *icpc*)
733 spec+=-icc 847 spec+=-icc ;;
734 else 848 *)
735 die "Unknown compiler ${CXX}." 849 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
736 fi 850 esac
737 if [[ -n ${LIBDIR/lib} ]]; then
738 spec+=-${LIBDIR/lib}
739 fi
740 851
741 # Add -64 for 64bit profiles 852 # Add -64 for 64bit profiles
742 if use x64-freebsd || 853 if use x64-freebsd ||
743 use amd64-linux || 854 use amd64-linux ||
744 use x64-macos || 855 use x64-macos ||
749 fi 860 fi
750 861
751 echo "${spec}" 862 echo "${spec}"
752} 863}
753 864
865# @FUNCTION: qt_nolibx11
866# @INTERNAL
867# @DESCRIPTION:
868# Ignore X11 tests for packages that don't need X libraries installed.
869qt_nolibx11() {
870 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
871 die "x11 check sed failed"
872}
873
754EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 874EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.133

  ViewVC Help
Powered by ViewVC 1.1.20